#include <xc.h>
#include "main.h"
#include "74hc299.h"
#include "bcd.h"


#pragma config WDTE = OFF
#pragma config PWRTE = ON
#pragma config CP = OFF
#pragma config BOREN = ON
#pragma config FOSC = HS

#define _XTAL_FREQ 200000  //  20/4=125 n


// 
//-------------------------------------------------------
volatile unsigned char uc_tok=0;
volatile unsigned char uc_napruga=0;
volatile unsigned char uc_yst_tok=0;
volatile unsigned char uc_yst_nap=0;

volatile unsigned char uc_isr_temp=0;
volatile unsigned char uc_flag_trm1=0;
volatile unsigned char uc_smen_acp=0;  // 0-,1-
struct knop
{
	unsigned char uc_tek;		//  0-
								//  1-
	unsigned char uc_new;
	unsigned char uc_press;
    unsigned char uc_off;
} s_knopki, *ykz_knopki;

volatile unsigned char uc_smena_dis=0; // 0-,1-
volatile unsigned char uc_display=0; //    3 
									 //   
volatile unsigned char uc_dis_yst=0; //   
									 // 
volatile unsigned char uc_flag_ind=0; //   
									  // 
unsigned char uc_lcd=0;
unsigned char uc_ypr=0;
//--------------------------------------------------------------------
// 
void interrupt my_isr(void) 	//  
{
	if(TMR1IE&&TMR1IF)
	{ 
        TMR1IF=0 ;
        uc_isr_temp++;
		if(uc_isr_temp>=8) //   
		{
			uc_isr_temp=0;
			uc_flag_trm1=1; //  1  
							//   
			uc_smen_acp++;
			ykz_knopki->uc_new=PORTA;
			uc_display++;
			if(uc_display>=6)  //   3   
			{
				uc_display=0;
				uc_smena_dis++;
			}
		}
    }

	if(TMR2IE&&TMR2IF)
	{
        TMR2IF=0;
        uc_flag_ind=1;
		uc_display++;
		if(uc_display>=4)
			uc_display=1;
	}
	
}//end_interrupt--------------------------



void main(void)
{
	ykz_knopki=&s_knopki;
		
	init();
	bcd_exe(45);
	while(1)
	{
		if(uc_flag_ind)
		{
			di();
				switch(uc_display){
			case 1:
				hc(bcd.uc_sotni,1);
				break;
			case 2:
				hc(bcd.uc_dec,2);
				break;
			case 3:
				hc(bcd.uc_edin,3);
				break;
			}
			uc_flag_ind=0;
             ei();
		}
	}
	
}


void init()
{
    //  
    TRISA=0xff;
    TRISB=0x00;
    TRISC=0x00;
	//   ADCON1=101 
	// RA0=TOK RA1=NAPRUGA RA3=VREF
    ADCON1=0b00000101;
    ADCON0=0b10000001;  //   RC, 0
						//  
	// 2     3
    T2CON=0b11110111; //  16, 16, ON
	PR2=58;
	// 1      .
	//       , 
	//         
	//   3 
	// 256*256*8*0.125=65536 =65 *8( )=520 
    T1CON=0b00110001;

	//    
	// 
	OPTION_REG=0b10001111; //  ,wdt =128
    INTCON=0b01000000; //    
	PIE1=0b00000011;   //    1,2
    PIR1=0x00;
    
    CCP1CON=0x00;
    SSPCON=0x00;
    ei();
}